#include "nrf_gpio.h"

#define NOP_COUNT (10000) // Works if changed to 1000

void SysTick_Handler(void)
{
}

int main(void)
{
    nrf_gpio_cfg_output(NRF_GPIO_PIN_MAP(0, 11));

    // Setup systick
    SysTick->LOAD  = (uint32_t)((SystemCoreClock / 1000) - 1UL);     // set reload register
    NVIC_SetPriority(SysTick_IRQn, (1UL << __NVIC_PRIO_BITS) - 1UL); // set Priority for Systick Interrupt
    SysTick->VAL   = 0UL;                                            // Load the SysTick Counter Value

    // Enable SysTick IRQ and SysTick Timer
    SysTick->CTRL = SysTick_CTRL_CLKSOURCE_Msk | SysTick_CTRL_TICKINT_Msk | SysTick_CTRL_ENABLE_Msk; // Works if this line is removed

    for (;;)
    {
        nrf_gpio_pin_toggle(NRF_GPIO_PIN_MAP(0, 11));

        for (uint32_t i = 0; i < NOP_COUNT; ++i)
            __NOP();

        //SysTick->CTRL &= ~ (SysTick_CTRL_TICKINT_Msk | SysTick_CTRL_ENABLE_Msk); // Irrelevant

        __WFE();
        // Clear the internal event register.
        __SEV();
        __WFE();

        //SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk | SysTick_CTRL_TICKINT_Msk; // Irrelevant

        nrf_gpio_pin_toggle(NRF_GPIO_PIN_MAP(0, 11));

        for (uint32_t i = 0; i < NOP_COUNT; ++i)
            __NOP();
    }
}